<?php
/**
 * Created by JetBrains PhpStorm.
 * User: victornovy
 * Date: 03/10/14
 * Time: 14:26
 * To change this template use File | Settings | File Templates.
 */

namespace Geral\Logic\RequisicaoEstoque;


use Estoque\Entities\Mensrequesto;
use Geral\Util\DateUtil;

class MensagemRequisicaoEstoque {

    // Formata a data de forma que possa ser inserida no banco
    public static function formataData($data)
    {
        if (strlen($data) == 19)
            $data = DateUtil::truncateString($data);
        $data = DateUtil::getDataDeString($data);
        $data = DateUtil::truncateData($data);

        return $data;
    }

    public static function verificaMensagem($filial, $requisicao, $produto, $organizacao)
    {
        $mensagem = Mensrequesto::findOneByCdfilialAndNrrequestoAndCdprodutoAndNrorg(
            $filial, $requisicao, $produto, $organizacao
        );
        return $mensagem;
    }

    public static function actionMensagem(
        $filial, $requisicao, $produto, $descricao, $organizacao, $organizacaoInclusao, $state,
        $organizacaoAlteracao, $operadorInclusao, $operadorAlteracao, $dataInclusao, $dataAlteracao
    )
    {
        $verifica = self::verificaMensagem($filial, $requisicao, $produto, $organizacao);

        if (!$verifica && $descricao) {
            self::insertMensagemRequisicao(
                $filial, $requisicao, $produto, $descricao, $organizacao, $organizacaoInclusao,
                $organizacaoAlteracao, $operadorInclusao, $operadorAlteracao, $dataInclusao, $dataAlteracao
            );
        } elseIf ($descricao) {
            self::updateMensagemRequisicao(
                $verifica, $descricao, $organizacaoAlteracao, $operadorAlteracao, $dataAlteracao
            );
        } elseIf ($state == 'U') {
            self::deleteMensagemRequisicao($verifica);
        }
    }

    public static function insertMensagemRequisicao(
        $filial, $requisicao, $produto, $descricao, $organizacao, $organizacaoInclusao,
        $organizacaoAlteracao, $operadorInclusao, $operadorAlteracao, $dataInclusao, $dataAlteracao
    )
    {
        /** @var $verifica Mensrequesto */
        $verifica = new Mensrequesto();
        $verifica->setCdfilial($filial);
        $verifica->setNrrequesto($requisicao);
        $verifica->setCdproduto($produto);
        $verifica->setDsobsrequest($descricao);
        $verifica->setNrorg($organizacao);
        $verifica->setNrorginclusao($organizacaoInclusao);
        $verifica->setNrorgultatu($organizacaoAlteracao);
        $verifica->setCdoperinclusao($operadorInclusao);
        $verifica->setCdoperultatu($operadorAlteracao);
        $verifica->setDtinclusao(self::formataData($dataInclusao));
        $verifica->setDtultatu(self::formataData($dataAlteracao));
        $verifica->persist();
        \Setforms2\Shared\Registry::getEntityManager()->flush();
    }

    public static function updateMensagemRequisicao(
        $verifica, $descricao, $organizacaoAlteracao, $operadorAlteracao, $dataAlteracao
    )
    {
        /** @var $verifica Mensrequesto */
        $verifica->setDsobsrequest($descricao);
        $verifica->setNrorgultatu($organizacaoAlteracao);
        $verifica->setCdoperultatu($operadorAlteracao);
        $verifica->setDtultatu(self::formataData($dataAlteracao));
        $verifica->persist();
        \Setforms2\Shared\Registry::getEntityManager()->flush();
    }

    public static function deleteMensagemRequisicao($verifica)
    {
        if ($verifica) {
            /** @var $verifica Mensrequesto */
            $verifica->delete();
            \Setforms2\Shared\Registry::getEntityManager()->flush();
        }
    }
}